/*===- TableGen'erated file -------------------------------------*- C++ -*-===*\
|*                                                                            *|
|* AttrDef Declarations                                                       *|
|*                                                                            *|
|* Automatically generated file, do not edit!                                 *|
|*                                                                            *|
\*===----------------------------------------------------------------------===*/

#ifdef GET_ATTRDEF_CLASSES
#undef GET_ATTRDEF_CLASSES


namespace mlir {
class AsmParser;
class AsmPrinter;
} // namespace mlir
namespace mlir {
namespace tosa {
/// Attribute for UnaryOp quantization information.
class UnaryOpQuantizationAttr;
/// Attribute for Conv type op quantization information.
class ConvOpQuantizationAttr;
/// Attribute for MatMulOp quantization information.
class MatMulOpQuantizationAttr;
/// Attribute for PadOp quantization information.
class PadOpQuantizationAttr;
/// supported TOSA extensions
class ExtensionAttr;
/// supported TOSA profiles
class ProfileAttr;
namespace detail {
struct UnaryOpQuantizationAttrStorage;
} // namespace detail
class UnaryOpQuantizationAttr : public ::mlir::Attribute::AttrBase<UnaryOpQuantizationAttr, ::mlir::Attribute, detail::UnaryOpQuantizationAttrStorage> {
public:
  using Base::Base;
  static constexpr ::llvm::StringLiteral name = "tosa.unary_quant";
  static constexpr ::llvm::StringLiteral dialectName = "tosa";
  static UnaryOpQuantizationAttr get(::mlir::MLIRContext *context, int64_t input_zp, int64_t output_zp);
  static constexpr ::llvm::StringLiteral getMnemonic() {
    return {"unary_quant"};
  }

  static ::mlir::Attribute parse(::mlir::AsmParser &odsParser, ::mlir::Type odsType);
  void print(::mlir::AsmPrinter &odsPrinter) const;
  int64_t getInputZp() const;
  int64_t getOutputZp() const;
};
namespace detail {
struct ConvOpQuantizationAttrStorage;
} // namespace detail
class ConvOpQuantizationAttr : public ::mlir::Attribute::AttrBase<ConvOpQuantizationAttr, ::mlir::Attribute, detail::ConvOpQuantizationAttrStorage> {
public:
  using Base::Base;
  static constexpr ::llvm::StringLiteral name = "tosa.conv_quant";
  static constexpr ::llvm::StringLiteral dialectName = "tosa";
  static ConvOpQuantizationAttr get(::mlir::MLIRContext *context, int64_t input_zp, int64_t weight_zp);
  static constexpr ::llvm::StringLiteral getMnemonic() {
    return {"conv_quant"};
  }

  static ::mlir::Attribute parse(::mlir::AsmParser &odsParser, ::mlir::Type odsType);
  void print(::mlir::AsmPrinter &odsPrinter) const;
  int64_t getInputZp() const;
  int64_t getWeightZp() const;
};
namespace detail {
struct MatMulOpQuantizationAttrStorage;
} // namespace detail
class MatMulOpQuantizationAttr : public ::mlir::Attribute::AttrBase<MatMulOpQuantizationAttr, ::mlir::Attribute, detail::MatMulOpQuantizationAttrStorage> {
public:
  using Base::Base;
  static constexpr ::llvm::StringLiteral name = "tosa.matmul_quant";
  static constexpr ::llvm::StringLiteral dialectName = "tosa";
  static MatMulOpQuantizationAttr get(::mlir::MLIRContext *context, int64_t a_zp, int64_t b_zp);
  static constexpr ::llvm::StringLiteral getMnemonic() {
    return {"matmul_quant"};
  }

  static ::mlir::Attribute parse(::mlir::AsmParser &odsParser, ::mlir::Type odsType);
  void print(::mlir::AsmPrinter &odsPrinter) const;
  int64_t getAZp() const;
  int64_t getBZp() const;
};
namespace detail {
struct PadOpQuantizationAttrStorage;
} // namespace detail
class PadOpQuantizationAttr : public ::mlir::Attribute::AttrBase<PadOpQuantizationAttr, ::mlir::Attribute, detail::PadOpQuantizationAttrStorage> {
public:
  using Base::Base;
  static constexpr ::llvm::StringLiteral name = "tosa.pad_quant";
  static constexpr ::llvm::StringLiteral dialectName = "tosa";
  static PadOpQuantizationAttr get(::mlir::MLIRContext *context, int64_t input_zp);
  static constexpr ::llvm::StringLiteral getMnemonic() {
    return {"pad_quant"};
  }

  static ::mlir::Attribute parse(::mlir::AsmParser &odsParser, ::mlir::Type odsType);
  void print(::mlir::AsmPrinter &odsPrinter) const;
  int64_t getInputZp() const;
};
namespace detail {
struct ExtensionAttrStorage;
} // namespace detail
class ExtensionAttr : public ::mlir::Attribute::AttrBase<ExtensionAttr, ::mlir::Attribute, detail::ExtensionAttrStorage> {
public:
  using Base::Base;
  static constexpr ::llvm::StringLiteral name = "tosa.ext";
  static constexpr ::llvm::StringLiteral dialectName = "tosa";
  static ExtensionAttr get(::mlir::MLIRContext *context, ::mlir::tosa::Extension value);
  static constexpr ::llvm::StringLiteral getMnemonic() {
    return {"ext"};
  }

  static ::mlir::Attribute parse(::mlir::AsmParser &odsParser, ::mlir::Type odsType);
  void print(::mlir::AsmPrinter &odsPrinter) const;
  ::mlir::tosa::Extension getValue() const;
};
namespace detail {
struct ProfileAttrStorage;
} // namespace detail
class ProfileAttr : public ::mlir::Attribute::AttrBase<ProfileAttr, ::mlir::Attribute, detail::ProfileAttrStorage> {
public:
  using Base::Base;
  static constexpr ::llvm::StringLiteral name = "tosa.prof";
  static constexpr ::llvm::StringLiteral dialectName = "tosa";
  static ProfileAttr get(::mlir::MLIRContext *context, ::mlir::tosa::Profile value);
  static constexpr ::llvm::StringLiteral getMnemonic() {
    return {"prof"};
  }

  static ::mlir::Attribute parse(::mlir::AsmParser &odsParser, ::mlir::Type odsType);
  void print(::mlir::AsmPrinter &odsPrinter) const;
  ::mlir::tosa::Profile getValue() const;
};
} // namespace tosa
} // namespace mlir
MLIR_DECLARE_EXPLICIT_TYPE_ID(mlir::tosa::UnaryOpQuantizationAttr)
MLIR_DECLARE_EXPLICIT_TYPE_ID(mlir::tosa::ConvOpQuantizationAttr)
MLIR_DECLARE_EXPLICIT_TYPE_ID(mlir::tosa::MatMulOpQuantizationAttr)
MLIR_DECLARE_EXPLICIT_TYPE_ID(mlir::tosa::PadOpQuantizationAttr)
MLIR_DECLARE_EXPLICIT_TYPE_ID(mlir::tosa::ExtensionAttr)
MLIR_DECLARE_EXPLICIT_TYPE_ID(mlir::tosa::ProfileAttr)

#endif  // GET_ATTRDEF_CLASSES

